import 'package:pip_services3_components/pip_services3_components.dart';
import 'package:pip_services3_commons/pip_services3_commons.dart';
import 'package:service_drones_dart/src/logic/DronesController.dart';
import 'package:service_drones_dart/src/persistence/persistence.dart';
import 'package:service_drones_dart/src/services/version1/service.dart';

class DronesServiceFactory extends Factory {
  static final MemoryPersistenceDescriptor = Descriptor(
      'eic-stopfires-services-drones', 'persistence', 'memory', '*', '1.0');
  static final FilePersistenceDescriptor = Descriptor(
      'eic-stopfires-services-drones', 'persistence', 'file', '*', '1.0');
  static final MongoDbPersistenceDescriptor = Descriptor(
      'eic-stopfires-services-drones', 'persistence', 'mongodb', '*', '1.0');
  static final ControllerDescriptor = Descriptor(
      'eic-stopfires-services-drones', 'controller', 'default', '*', '1.0');
  static final CommandableHttpServiceV1Descriptor = Descriptor(
      'eic-stopfires-services-drones',
      'service',
      'commandable-http',
      '*',
      '1.0');

  DronesServiceFactory() : super() {
    registerAsType(DronesServiceFactory.MemoryPersistenceDescriptor,
        DronesMemoryPersistence);
    registerAsType(
        DronesServiceFactory.FilePersistenceDescriptor, DronesFilePersistence);
    registerAsType(DronesServiceFactory.MongoDbPersistenceDescriptor,
        DronesMongoDbPersistence);
    registerAsType(DronesServiceFactory.ControllerDescriptor, DronesController);
    registerAsType(DronesServiceFactory.CommandableHttpServiceV1Descriptor,
        DronesCommandableServiceV1);
  }
}
