import 'dart:async';

import 'package:pip_services3_commons/pip_services3_commons.dart';
import 'package:service_drones_dart/src/data/version1/DroneV1.dart';

abstract class IDronesPersistence {
  Future<DataPage<DroneV1?>> getPageByFilter(
      String? correlationId, FilterParams filter, PagingParams paging);

  Future<DroneV1?> getOneById(String? correlationId, String droneId);

  Future<DroneV1?> getOneBySerial(String? correlationId, String serial);

  Future<DroneV1?> create(String? correlationId, DroneV1 drone);

  Future<DroneV1?> update(String? correlationId, DroneV1 drone);

  Future<DroneV1?> deleteById(String? correlationId, String droneId);
}
