import 'package:service_drones_dart/src/persistence/persistence.dart';
import 'package:test/test.dart';
import 'package:pip_services3_commons/pip_services3_commons.dart';

import 'DronesPersistenceFixture.dart';

void main() {
  group('DronesFilePersistence', () {
    late DronesFilePersistence persistence;
    late DronesPersistenceFixture fixture;

    setUp(() async {
      persistence = DronesFilePersistence();
      persistence.configure(
          ConfigParams.fromTuples(['path', './data/drones.test.json']));

      fixture = DronesPersistenceFixture(persistence);

      await persistence.open(null);
      await persistence.clear(null);
    });

    tearDown(() async {
      await persistence.close(null);
    });

    test('CRUD Operations', () async {
      await fixture.testCrudOperations();
    });

    test('Get with Filters', () async {
      await fixture.testGetWithFilters();
    });
  });
}
