import 'package:service_drones_dart/src/persistence/persistence.dart';
import 'package:test/test.dart';
import 'package:pip_services3_commons/pip_services3_commons.dart';

import './DronesPersistenceFixture.dart';

void main() {
  group('DronesMemoryPersistence', () {
    late DronesMemoryPersistence persistence;
    late DronesPersistenceFixture fixture;

    setUp(() async {
      persistence = DronesMemoryPersistence();
      persistence.configure(ConfigParams());

      fixture = DronesPersistenceFixture(persistence);

      await persistence.open(null);
    });

    tearDown(() async {
      await persistence.close(null);
    });

    test('CRUD Operations', () async {
      await fixture.testCrudOperations();
    });

    test('Get with Filters', () async {
      await fixture.testGetWithFilters();
    });
  });
}
